import sys
import struct
import redis, hiredis
import rediscan
import time
import math

def init():
    global client
    client = rediscan.init()
    rediscan.open()


def done():
    rediscan.close()
    del client


def hyro_get_tele(sid=9, did=1):
    global client
    k = []; v = []; h = []
    for i in range(0, 3):
        k.append("%x:%x:b1%d" % (sid, did, i))
    v = client.mget(k[0], k[1], k[2])
    for i in range(0, 3):
        h.append(struct.unpack('<fbx', v[i]))
    return h

def mag_get_tele(sid=9, did=1):
    global client
    k = []; v = []; h = []
    for i in range(3, 6):
        k.append("%x:%x:b1%d" % (sid, did, i))
    v = client.mget(k[0], k[1], k[2])
    for i in range(0, 3):
        h.append(struct.unpack('<fbx', v[i]))
    return h

def vms_tele_req(sid=1, did=9):
    rediscan.unisend(sid, did, 0xb01, "", 1)


def vms_tele_off(sid=1, did=9):
    rediscan.unisend(sid, did, 0xb22, "", 1)


def vms_tele_on(sid=1, did=9, period=0x8000):
    rediscan.unisend(sid, did, 0xb22, struct.pack('<H', period), 1)

def coil_set_state2(coil1=2, coil2=2, coil3=2, sid=1, did=9):
    if coil1 == 1:
        rediscan.unisend(sid, did, 0x03, "", 1)
        time.sleep(0.050)
    elif coil1 == -1:
        rediscan.unisend(sid, did, 0x04, "", 1)
        time.sleep(0.050)
    elif coil1 == 0:
        rediscan.unisend(sid, did, 0x05, "", 1)
        time.sleep(0.050)


    if coil2 == 1:
        rediscan.unisend(sid, did, 0x06, "", 1)
        time.sleep(0.050)
    elif coil2 == -1:
        rediscan.unisend(sid, did, 0x07, "", 1)
        time.sleep(0.050)
    elif coil2 == 0:
        rediscan.unisend(sid, did, 0x08, "", 1)
        time.sleep(0.050)


    if coil3 == 1:
        rediscan.unisend(sid, did, 0x09, "", 1)
        time.sleep(0.050)
    elif coil3 == -1:
        rediscan.unisend(sid, did, 0x0A, "", 1)
        time.sleep(0.050)
    elif coil3 == 0:
        rediscan.unisend(sid, did, 0x0B, "", 1)
        time.sleep(0.050)

def coil_set_state(coil1=2, coil2=2, coil3=2, sid=1, did=9):
    val = 0
    if coil1 == 1:
        val = val+1
    elif coil1 == -1:
        val = val+2

    if coil2 == 1:
        val = val+4
    elif coil2 == -1:
        val = val+8

    if coil3 == 1:
        val = val+16
    elif coil3 == -1:
        val = val+32
    rediscan.unisend(sid, did, 0x0D, struct.pack('B', val), 1)

