import redis, hiredis

def G():
    pass

G.sock = -1

G.canInitLua = "require 'libluacan'"
G.canOpenLua = "return libluacan.open(ARGV[1])"
G.canSendLua = "libluacan.send(ARGV[1], ARGV[2], ARGV[3])"
G.canUniSendLua = "libluacan.unisend(ARGV[1], ARGV[2], ARGV[3], ARGV[4], ARGV[5], ARGV[6])"
G.canCloseLua = "libluacan.close(ARGV[1])"


def init(ipaddr='192.168.42.1'):
    G.client = redis.Redis(host=ipaddr)

    G.canInit = G.client.register_script(G.canInitLua)
    G.canOpen = G.client.register_script(G.canOpenLua)
    G.canClose = G.client.register_script(G.canCloseLua)
    G.canSend = G.client.register_script(G.canSendLua)
    G.canUniSend = G.client.register_script(G.canUniSendLua)

    G.canInit()

    return G.client


def open(name='can0'):
    G.sock = G.canOpen(args=[name]);


def close():
    G.canClose(args=[G.sock]);
    G.sock = -1


def send(can_id, can_data):
    G.canSend(args=[G.sock, can_id, can_data])


def unisend(sid, did, mid, data, compact=0):
    G.canUniSend(args=[G.sock, sid, did, mid, data, compact])


def unirecv(sid, did, mid):
    if G.client.exists("%x:%x:%x" % (sid, did, mid)):
        return G.client.get("%x:%x:%x" % (sid, did, mid))
    else:
        return ""
